MultiTermQuery (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.search, class: MultiTermQuery

Package org.apache.lucene.search

# Class MultiTermQuery

java.lang.Object
org.apache.lucene.search.Query
org.apache.lucene.search.MultiTermQuery

Direct Known Subclasses:
  `AutomatonQuery`, `FuzzyQuery`, `TermInSetQuery`

public abstract class MultiTermQuery extends Query
An abstract `Query` that matches documents containing a subset of terms provided by a `FilteredTermsEnum` enumeration.

This query cannot be used directly; you must subclass it and define `getTermsEnum(Terms,AttributeSource)` to provide a `FilteredTermsEnum` that iterates through the terms to be matched.

NOTE: if `MultiTermQuery.RewriteMethod` is either `CONSTANT_SCORE_BOOLEAN_REWRITE` or `SCORING_BOOLEAN_REWRITE`, you may encounter a `IndexSearcher.TooManyClauses` exception during searching, which happens when the number of terms to be searched exceeds `IndexSearcher.getMaxClauseCount()`. Setting `MultiTermQuery.RewriteMethod` to `CONSTANT_SCORE_BLENDED_REWRITE` or `CONSTANT_SCORE_REWRITE` prevents this.

The recommended rewrite method is `CONSTANT_SCORE_BLENDED_REWRITE`: it doesn't spend CPU computing unhelpful scores, and is the most performant rewrite method given the query. If you need scoring (like `FuzzyQuery`, use `MultiTermQuery.TopTermsScoringBooleanQueryRewrite` which uses a priority queue to only collect competitive terms and not hit this limitation.

Note that org.apache.lucene.queryparser.classic.QueryParser produces MultiTermQueries using `CONSTANT_SCORE_REWRITE` by default.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `MultiTermQuery.RewriteMethod`
  Abstract class that defines how the query is rewritten.
  `static final class`
  `MultiTermQuery.TopTermsBlendedFreqScoringRewrite`
  A rewrite method that first translates each term into `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, but adjusts the frequencies used for scoring to be blended across the terms, otherwise the rarest term typically ranks highest (often not useful eg in the set of expanded terms in a FuzzyQuery).
  `static final class`
  `MultiTermQuery.TopTermsBoostOnlyBooleanQueryRewrite`
  A rewrite method that first translates each term into `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, but the scores are only computed as the boost.
  `static final class`
  `MultiTermQuery.TopTermsScoringBooleanQueryRewrite`
  A rewrite method that first translates each term into `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, and keeps the scores as computed by the query.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final MultiTermQuery.RewriteMethod`
  `CONSTANT_SCORE_BLENDED_REWRITE`
  A rewrite method where documents are assigned a constant score equal to the query's boost.
  `static final MultiTermQuery.RewriteMethod`
  `CONSTANT_SCORE_BOOLEAN_REWRITE`
  Like `SCORING_BOOLEAN_REWRITE` except scores are not computed.
  `static final MultiTermQuery.RewriteMethod`
  `CONSTANT_SCORE_REWRITE`
  A rewrite method that first creates a private Filter, by visiting each term in sequence and marking all docs for that term.
  `static final MultiTermQuery.RewriteMethod`
  `DOC_VALUES_REWRITE`
  A rewrite method that uses `DocValuesType.SORTED` / `DocValuesType.SORTED_SET` doc values to find matching docs through a post-filtering type approach.
  `protected final String`
  `field`
  `protected final MultiTermQuery.RewriteMethod`
  `rewriteMethod`
  `static final MultiTermQuery.RewriteMethod`
  `SCORING_BOOLEAN_REWRITE`
  A rewrite method that first translates each term into `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, and keeps the scores as computed by the query.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MultiTermQuery(String field, MultiTermQuery.RewriteMethod rewriteMethod)`
  Constructs a query matching terms that cannot be represented with a single Term.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object other)`
  Override and implement query instance equivalence properly in a subclass.
  `final String`
  `getField()`
  Returns the field name for this query
  `MultiTermQuery.RewriteMethod`
  `getRewriteMethod()`
  `long`
  `getTermsCount()`
  Return the number of unique terms contained in this query, if known up-front.
  `final TermsEnum`
  `getTermsEnum(Terms terms)`
  Constructs an enumeration that expands the pattern term.
  `protected abstract TermsEnum`
  `getTermsEnum(Terms terms, AttributeSource atts)`
  Construct the enumeration to be used, expanding the pattern term.
  `int`
  `hashCode()`
  Override and implement query hash code properly in a subclass.
  `final Query`
  `rewrite(IndexSearcher indexSearcher)`
  To rewrite to a simpler form, instead return a simpler enum from `getTermsEnum(Terms, AttributeSource)`.

  ### Methods inherited from class org.apache.lucene.search.Query

  `classHash, createWeight, sameClassAs, toString, toString, visit`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### field

    protected final String field

  - ### rewriteMethod

    protected final MultiTermQuery.RewriteMethod rewriteMethod

  - ### CONSTANT_SCORE_BLENDED_REWRITE

    public static final MultiTermQuery.RewriteMethod CONSTANT_SCORE_BLENDED_REWRITE
    A rewrite method where documents are assigned a constant score equal to the query's boost. Maintains a boolean query-like implementation over the most costly terms while pre-processing the less costly terms into a filter bitset. Enforces an upper-limit on the number of terms allowed in the boolean query-like implementation.

    This method aims to balance the benefits of both `CONSTANT_SCORE_BOOLEAN_REWRITE` and `CONSTANT_SCORE_REWRITE` by enabling skipping and early termination over costly terms while limiting the overhead of a BooleanQuery with many terms. It also ensures you cannot hit `IndexSearcher.TooManyClauses`. For some use-cases with all low cost terms, `CONSTANT_SCORE_REWRITE` may be more performant. While for some use-cases with all high cost terms, `CONSTANT_SCORE_BOOLEAN_REWRITE` may be better.

  - ### CONSTANT_SCORE_REWRITE

    public static final MultiTermQuery.RewriteMethod CONSTANT_SCORE_REWRITE
    A rewrite method that first creates a private Filter, by visiting each term in sequence and marking all docs for that term. Matching documents are assigned a constant score equal to the query's boost.

    This method is faster than the BooleanQuery rewrite methods when the number of matched terms or matched documents is non-trivial. Also, it will never hit an errant `IndexSearcher.TooManyClauses` exception.

  - ### DOC_VALUES_REWRITE

    public static final MultiTermQuery.RewriteMethod DOC_VALUES_REWRITE
    A rewrite method that uses `DocValuesType.SORTED` / `DocValuesType.SORTED_SET` doc values to find matching docs through a post-filtering type approach. This will be very slow if used in isolation, but will likely be the most performant option when combined with a sparse query clause. All matching docs are assigned a constant score equal to the query's boost.

    If you don't have doc values indexed, see the other rewrite methods that rely on postings alone (e.g., `CONSTANT_SCORE_BLENDED_REWRITE`, `SCORING_BOOLEAN_REWRITE`, etc. depending on scoring needs).

  - ### SCORING_BOOLEAN_REWRITE

    public static final MultiTermQuery.RewriteMethod SCORING_BOOLEAN_REWRITE
    A rewrite method that first translates each term into `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, and keeps the scores as computed by the query. Note that typically such scores are meaningless to the user, and require non-trivial CPU to compute, so it's almost always better to use `CONSTANT_SCORE_REWRITE` instead.

    NOTE: This rewrite method will hit `IndexSearcher.TooManyClauses` if the number of terms exceeds `IndexSearcher.getMaxClauseCount()`.

  - ### CONSTANT_SCORE_BOOLEAN_REWRITE

    public static final MultiTermQuery.RewriteMethod CONSTANT_SCORE_BOOLEAN_REWRITE
    Like `SCORING_BOOLEAN_REWRITE` except scores are not computed. Instead, each matching document receives a constant score equal to the query's boost.

    NOTE: This rewrite method will hit `IndexSearcher.TooManyClauses` if the number of terms exceeds `IndexSearcher.getMaxClauseCount()`.

- ## Constructor Details

  - ### MultiTermQuery

    public MultiTermQuery(String field, MultiTermQuery.RewriteMethod rewriteMethod)
    Constructs a query matching terms that cannot be represented with a single Term.

- ## Method Details

  - ### getField

    public final String getField()
    Returns the field name for this query

  - ### getTermsEnum

    protected abstract TermsEnum getTermsEnum(Terms terms, AttributeSource atts) throws IOException
    Construct the enumeration to be used, expanding the pattern term. This method should only be called if the field exists (ie, implementations can assume the field does exist). This method should not return null (should instead return `TermsEnum.EMPTY` if no terms match). The TermsEnum must already be positioned to the first matching term. The given `AttributeSource` is passed by the `MultiTermQuery.RewriteMethod` to share information between segments, for example `TopTermsRewrite` uses it to share maximum competitive boosts
    Throws:
      `IOException`

  - ### getTermsEnum

    public final TermsEnum getTermsEnum(Terms terms) throws IOException
    Constructs an enumeration that expands the pattern term. This method should only be called if the field exists (ie, implementations can assume the field does exist). This method never returns null. The returned TermsEnum is positioned to the first matching term.
    Throws:
      `IOException`

  - ### getTermsCount

    public long getTermsCount()
    Return the number of unique terms contained in this query, if known up-front. If not known, -1 will be returned.

  - ### rewrite

    public final Query rewrite(IndexSearcher indexSearcher) throws IOException
    To rewrite to a simpler form, instead return a simpler enum from `getTermsEnum(Terms, AttributeSource)`. For example, to rewrite to a single term, return a `SingleTermsEnum`
    Overrides:
      `rewrite` in class `Query`
    Throws:
      `IOException`
    See Also:
      - `IndexSearcher.rewrite(Query)`

  - ### getRewriteMethod

    public MultiTermQuery.RewriteMethod getRewriteMethod()
    Returns:
      the rewrite method used to build the final query

  - ### hashCode

    public int hashCode()
    Description copied from class: `Query`
    Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
    Specified by:
      `hashCode` in class `Query`
    See Also:
      - `Query.equals(Object)`

  - ### equals

    public boolean equals(Object other)
    Description copied from class: `Query`
    Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

    Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical to those of the other instance. Utility methods are provided for certain repetitive code.

    Specified by:
      `equals` in class `Query`
    See Also:
      - `Query.sameClassAs(Object)`
      - `Query.classHash()`